/*
 * $0.39$
 * Class DepDC
 * Generated from table: DEP
 * Schema: SCOTT
 * Database: 
 *  
 * @since: Tue Mar 23 00:40:32 CET 2004
*/
package sql2class.sql2datac;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.Vector;
import org.brains2b.data.Condition;
import org.brains2b.sql.oracle.OracleCondition;
import org.brains2b.sql.oracle.OracleDC;

public class DepDC extends OracleDC {

    public  DepDC(Connection con, Object o) {
        super(con,o); 
    } 

    public int deleteOnPk() throws Exception {
        Dep dep = (Dep) mObj;
        mPrep=mCon.prepareStatement(
        "DELETE FROM DEP WHERE DEPNO= ? ");
        		 mPrep.setInt(1,dep.getDepno());
        
        int result=mPrep.executeUpdate();
        mPrep.close();
        return result;
    } 

    protected Object getObject(ResultSet rs) throws Exception {
        Dep dep = new Dep(
        	rs.getInt(1),
        	rs.getString(2),
        	rs.getString(3));
        dep.setChecksum(dep.hashCode());
        return dep;
    } 

    public int insert() throws Exception {
        Dep dep = (Dep) mObj;
        if(dep.getDepno() ==0) {
            throw new Exception("Cannot insert record with empty primary key");
        }
        mPrep=mCon.prepareStatement(
        "INSERT INTO DEP (DEPNO,DNAME,LOC) VALUES ( ?,?,?)");
        mPrep.setInt(1,dep.getDepno());
        mPrep.setString(2,dep.getDname());
        mPrep.setString(3,dep.getLoc());
        
        int result=mPrep.executeUpdate();
        mPrep.close();
        dep.setChecksum(dep.hashCode());
        return result;
    } 

    public Vector selectAll() throws Exception {
        Vector v=new Vector();
        mPrep=mCon.prepareStatement(
        "SELECT DEPNO,DNAME,LOC FROM DEP");
        
        ResultSet rs=mPrep.executeQuery();
        while (rs.next()) {
            v.add(getObject(rs));
        }
        mPrep.close(); 
        if(v.isEmpty()) {
            return null;
        }
        return v;
    } 

    public Vector selectFromCondition(Condition con) throws Exception {
        Vector v=new Vector();
        String select= "SELECT DEPNO,DNAME,LOC FROM DEP";
        mPrep=((OracleCondition) con).getPreparedStatement(mCon,select);
        
        ResultSet rs=mPrep.executeQuery();
        while (rs.next()) {
            v.add(getObject(rs));
        }
        mPrep.close(); 
        if(v.isEmpty()) {
            return null;
        }
        return v;
    } 

    public Vector selectOnParent(Object o) throws Exception {
        return null;
    } 

    public Object selectOnPk(Object o) throws Exception {
        Dep dep = (Dep) o;
        mPrep=mCon.prepareStatement(
        "SELECT DEPNO,DNAME,LOC FROM DEP WHERE DEPNO= ? ");
        mPrep.setInt(1,dep.getDepno());
        
        ResultSet rs=mPrep.executeQuery();
        Object out=null;
        if(rs.next()) {
            out= getObject(rs);
        }
        mPrep.close();
        return out;
    } 

    public int updateOnPk() throws Exception {
        Dep dep = (Dep) mObj;
        if (dep.getChecksum()==0)  return insert();
        if( selectOnPk(dep).hashCode()!=dep.getChecksum()) {
            throw new Exception("Record has been changed by another user");
        }
        mPrep=mCon.prepareStatement("UPDATE DEP SET DNAME=?,LOC=? WHERE DEPNO= ? ");
        mPrep.setString(1,dep.getDname());
        mPrep.setString(2,dep.getLoc());
        mPrep.setInt(3,dep.getDepno());
        
        int result=mPrep.executeUpdate();
        mPrep.close();
        dep.setChecksum( selectOnPk(dep).hashCode());
        return result;
    } 

} 
